/* ***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1/GPL 2.0/LGPL 2.1

The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS"
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is Standard-Sitemap Navigator code.

The Initial Developer of the Original Code is the
Standard-Sitemap Team.

Contributor(s): (see license.txt)

Alternatively, the contents of this file may be used under the terms of
either the GNU General Public License Version 2 or later (the "GPL"), or
the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
in which case the provisions of the GPL or the LGPL are applicable instead
of those above. If you wish to allow use of your version of this file only
under the terms of either the GPL or the LGPL, and not to allow others to
use your version of this file under the terms of the MPL, indicate your
decision by deleting the provisions above and replace them with the notice
and other provisions required by the GPL or the LGPL. If you do not delete
the provisions above, a recipient may use your version of this file under
the terms of any one of the MPL, the GPL or the LGPL.
***** END LICENSE BLOCK ***** */


/*ToDo: Clean up! Remove all code that got left behind when splitting the Sidebar and the StandardSitemap*/
/*ToDo: Rewrite comments to apply to current code...*/
var SitemapSidebar = {
    lib : Application.storage.get("org.standard-sitemap.library", null),

    monitor : window.top["org.standard-sitemap.monitor"],

    oSitemap: null,
    currentSitemapUrl : null,
    tree : null,
    searchBox : null,
    preferedLanguages: null,
    //sSelectedLanguage: "",
    selectedFormat : 'html',
    treeItemList : [], //Can't find the getRowCount method and get some errors so lets do his manually for now
    panelId : null,
    browser : null, //The browser for the tab we're in

    oAgent : null,
    removeListener : null,

    sourceButton1 : null,
    sourceButton2 : null,
    rootElem : null,
    whereAmIButton : null,

    lastSitemapURI : null,

    fSetVisibility : null,

    fSetAvailability : null,

    ioSvc : null,

    // This is the xul:notificationbox element that contains
    // references to the sidebar components.  It should be set once
    // 'onLoad', and used in preference to re-walking from
    // this.browser, since that walking might fail as FF develops.
    oPanel : null,

    onLoad : function(event) {
        var self = this;

        //Let's get some info about the tab we're in
        if (true) {
            // TODO: Drop this section if the alternative is reliable.
            this.panelId = document.location.hash.replace('#', '');
            this.oPanel = window.top.getBrowser().ownerDocument
                .getElementById(this.panelId);
            // Pre-FF4, the browser is the child of the panel.  From
            // FF4 onwards, it is the first child of the second child.
            this.browser = this.oPanel.childNodes[0];
            if (this.browser.localName != "browser" ||
                this.browser.namespaceURI != this.lib.xulNS)
                this.browser = this.oPanel.childNodes[0].childNodes[0];
            if (this.browser.localName != "browser" ||
                this.browser.namespaceURI != this.lib.xulNS)
                this.lib.debug("Can't find browser for " + this.panelId);
        } else {
            // TODO: This section is not reliable for some versions
            // before FF3.5.3, e.g. 3.0.10.
            this.panelId = document.getUserData('org.standard-sitemap.id');
            this.browser = document.getUserData('org.standard-sitemap.browser');

            // TODO: oPanel is not set, if you want to use this
            // branch.
        }

        this.browser.setUserData('org.standard-sitemap.sidebar', this, null);

        this.ioSvc = Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService);

        this.historyListener = {
            QueryInterface : function(aIID) {
                if (aIID.equals(Components.interfaces
                                .nsISHistoryListener) ||
                    aIID.equals(Components.interfaces
                                .nsISupportsWeakReference) ||
                    aIID.equals(Components.interfaces.nsISupports))
                    return this;
                throw Components.results.NS_NOINTERFACE;
            },

            OnHistoryReload : function(oURI, flags) { return true; },

            OnHistoryGoBack : function(oURI) { return true; },

            OnHistoryGoForward : function(oURI) { return true; },

            OnHistoryGotoIndex : function(iIndex, oURI) { return true; },

            OnHistoryNewEntry : function(oURI) {
                self.newHistoryEntry();
            },

            OnHistoryPurge : function(iNumEntries) {
                // TODO: Improve this, as it will fail if another
                // listener decides to forbid the purge.  We really
                // need an onPostHistoryPurge method.
                self.historyPurge(iNumEntries);
                return true;
            },
        };
        this.historyItems = [];
        this.browser.sessionHistory.addSHistoryListener(this.historyListener);

        this.oAgent = this.monitor.getAgentForBrowser(this.browser);
        var fAgentListener = function(bForceChange, sReason) {
            self.catchUp(bForceChange, sReason);
        };
        this.removeListener = function() {
            self.oAgent.removeListener(fAgentListener);
        };

        this.lib.oObserverService
            .addObserver(this.sitemapPrefObserver,
                         "standard-sitemap-prefchanged", false); 

        this.fSetVisibility = this.browser.getUserData
        ('org.standard-sitemap.sidebar.setVisibility');

        this.fSetAvailability = this.browser.getUserData
        ('org.standard-sitemap.sidebar.setAvailability');

        this.tree = document.getElementById('sitetree');
        this.searchBox = document.getElementById('sitemap-search-box');

        this.sourceButton1 = document.getElementById("sourcecode1-button");
        this.sourceButton2 = document.getElementById("sourcecode2-button");

        this.rootElem = document.getElementById('sitemapSidebar');

        var osString = Components.classes["@mozilla.org/xre/app-info;1"]  
            .getService(Components.interfaces.nsIXULRuntime).OS;
        if (osString == "Darwin")
            this.lib.xulAddClass(this.rootElem, 'on-mac');

        this.whereAmIButton = document.getElementById('whereami-button');

        // Detect when the splitter has been dropped.
        this.oPanel.mStandardSitemapSplitter
            .addEventListener('command', function(event) {
                self.HandleSidebarResize(event);
            }, false);

        // Orient the toolbar according to configuration.
        if (this.lib.getBoolPref("vertbar")) {
            this.setVerticalToolbar();
        } else {
            this.setHorizontalToolbar();
        }

        this.oAgent.addListener(fAgentListener);
        this.catchUp(false, 'init');
    },

    bVisible : false,

    toggleVisibility : function(bUserCommand) {
        this.setVisibility(!this.bVisible, bUserCommand);
    },

    setSitePref : function(oSitemapURI, suffix, value) {
        this.lib.debug('At ' + oSitemapURI.spec + " setting " +
                       suffix + "=" + value);
        this.lib.setContentPref(oSitemapURI,
                                'org.standard-sitemap.sidebar.' + suffix,
                                value);
    },

    removeSitePref : function(oSitemapURI, suffix) {
        this.lib.removeContentPref(oSitemapURI,
                                   'org.standard-sitemap.sidebar.' + suffix);
    },

    getSitePref : function(oSitemapURI, suffix) {
        var orig = oSitemapURI;

        // Try the new location first.
        var pref = this.lib
            .getContentPref(oSitemapURI,
                            'org.standard-sitemap.sidebar.' + suffix);
        if (pref != null) {
            this.lib.debug('At ' + oSitemapURI.spec +
                           ' found ' + suffix + '=' + pref);
            return pref;
        }

        // No new setting, so try the old one.
        pref = this.lib.getContentPref(orig, 'standardsitemap.' + suffix);
        if (pref == null)
            return pref;

        // Copy the old preference to the new, and delete the old.
        this.lib.debug('At ' + oSitemapURI.spec + " copying " +
                       suffix + "=" + pref);
        this.lib.setContentPref(oSitemapURI,
                                'org.standard-sitemap.sidebar.' + suffix,
                                pref);
        this.lib.removeContentPref(orig, 'standardsitemap.' + suffix);

        return pref;
    },

    getVisibilityPref : function(oSitemapURI, bDefault) {
        var pref = this.getSitePref(oSitemapURI, 'sidebarvisible');
        var result;
        var reason = 'recovered as';
        if (pref) {
            result = true;
        } else if (typeof pref == "undefined") {
            result = bDefault;
            reason = 'assumed to be'
        } else {
            result = false;
        }
        if (false) {
            this.lib.debug('Visibility pref of ' + oSitemapURI.spec +
                           ' ' + reason + ' ' + !!result);
        }
        return result;
    },

    setVisibility : function(bVisible, bUserCommand) {
        this.bVisible = bVisible;
        if (bUserCommand) {
            // The user has ordered this change, so record that as a
            // preference.
            var sitemapURI = this.oAgent.getSitemapURI();
            if (sitemapURI) {
                var sitemapKey = sitemapURI;
            } else {
                var sitemapKey = this.lib.makeURI('null:');
            }
            this.setSitePref(sitemapKey, 'sidebarvisible', !!this.bVisible);
            if (false) {
                this.lib.debug('Visibility pref of ' + sitemapKey.spec +
                               ' set to ' + this.bVisible);
            }
        }
        this.fSetVisibility(bVisible);
        this.updateDisplayLevel();
    },


    getLanguagePref: function() {
        var oSitemapURI = this.oAgent.getSitemapURI();
        if (!oSitemapURI) return [];
        var pref = this.getSitePref(oSitemapURI, 'sidebarlanguagepref');
        if (pref) return pref.split(',');
        return this.lib.GetAcceptLanguages();
    },

    clearLanguagePref: function() {
        // There can be no preference for a site without a sitemap.
        var oSitemapURI = this.oAgent.getSitemapURI();
        if (!oSitemapURI) return;
        this.removeSitePref(oSitemapURI, 'sidebarlanguagepref');
        var self = this;
        setTimeout(function() {
            self.updateLanguageContent();
            self.updateLanguageDisplay();
        });
    },

    setLanguagePref: function(newLang) {
        newLang = newLang.trim().toLowerCase();
        // There can be no preference for a site without a sitemap.
        var oSitemapURI = this.oAgent.getSitemapURI();
        if (!oSitemapURI) return;

        // Get the current preference, remove the language from the
        // sequence, then put it at the head.
        var pref = this.getLanguagePref();
        var pos = pref.indexOf(newLang);
        if (pos >= 0)
            pref = pref.slice(0, pos).concat(pref.slice(pos + 1));
        pref = [ newLang ].concat(pref);
        // TODO: If en is the new setting, move all en-* up with it,
        // in the order they previously appeared.  If en-gb is the new
        // setting, move all en-* in the same order, but put en-GB
        // first.


        // Record the new preference.
        this.setSitePref(oSitemapURI, 'sidebarlanguagepref', pref.toString());
        this.lib.debug('New language preference ' + pref +
                       ' for ' + oSitemapURI.spec + " " + typeof(pref));

        var self = this;
        setTimeout(function() {
            self.updateLanguageContent();
            self.updateLanguageDisplay();
        });
    },

    updateLanguageContent: function() {
        this.preferedLanguages = this.getLanguagePref();
        this.preferedLanguages.push(null);

        // If the sitemap is present, re-evaluate the content
        if (!this.oSitemap) return;

        for each (var treeItem in this.treeItemList) {
            var item = treeItem.sourceNode;
            var content = item.GetContent(this.preferedLanguages);
            var itemName = content['name'];
            this.updateLanguageContentInItem(treeItem, item,
                                             content, itemName);
        }
    },

    updateLanguageContentInItem: function(treeItem, item, content, itemName) {
        var itemUrl = content['addr'];
        var itemDescription = content['desc'];
        var bVisited = this.lib.isVisitied(itemUrl);
        itemUrl = itemUrl ? itemUrl.spec : null;

        treeItem.cell.setAttribute('label', itemName);
        var sTooltip = itemName.replace('\\s+', ' ');
        if (itemDescription)
            sTooltip += '\n' + itemDescription.replace('\\s+', ' ');
        treeItem.cell.setAttribute('tooltiptext', sTooltip);

        if (itemUrl) {
            treeItem.url = itemUrl;
            treeItem.cell
                .setAttribute('properties',
                              treeItem.cell.getAttribute('properties') +
                              ' treeItemLink');
            if (bVisited)
                treeItem.cell
                .setAttribute('properties',
                              treeItem.cell.getAttribute('properties') +
                              ' visited');
            treeItem.row
                .setAttribute('properties',
                              treeItem.row.getAttribute('properties') +
                              ' treeItemLink');
        }
    },

    updateLanguageDisplay: function() {
        var button = document.getElementById('language-button');
        var menu = document.getElementById('langpopup');
        var self = this;

        this.lib.xulRemoveAllChildren(menu);
        if (!this.oSitemap) {
            button.setAttribute('disabled', true);
            return;
        }

        var makeFunc = function(s) {
            return function() { self.setLanguagePref(s); };
        };

        // Find out what languages are offered by the sitemap.
        var options = this.oSitemap.GetLanguages();
        if (false)
            this.lib.debug("Setting language menu to " + options +
                           " (" + options.length + ")");

        // Create an item for each offered language.
        for each (var lang in options) {
            // Change this to the language name in its own language.
            var displayName = this.lib.nameLanguageCode(lang);

            var item =
                document.createElement('menuitem', this.lib.xulNS);
            item.setAttribute('label', displayName);
            item.onclick = makeFunc(lang);
            menu.appendChild(item);
            // TODO: Add a tick if current selection is matched.
        }

        // Add a default item (optionally preceded by separator).
        if (options.length > 0) {
            var item =
                document.createElement('menuseparator', this.lib.xulNS);
            menu.appendChild(item);
        }
        var defaultItem = document.getElementById('default-language-item');
        var item = defaultItem.cloneNode(true);
        item.onclick = function() { self.clearLanguagePref(); };
        menu.appendChild(item);

        // Ensure that the menu is available.
        button.removeAttribute('disabled');
    },

    // Make sure that the sidebar is up-to-date with respect to the
    // current sitemap and page.
    catchUp : function(bForceChange, sReason) {
        // Re-read the prefered languages, and make sure we accept
        // anything if nothing matches exactly.
        this.preferedLanguages = this.getLanguagePref();
        this.preferedLanguages.push(null);

        var self = this;

        var bAutoOpen = this.lib.getBoolPref("autoopen");
        var sitemapURI = this.oAgent.getSitemapURI();
        var location = this.oAgent.getLocation();

        if (true)
            this.lib.debug('Sidebar ' + this.panelId +
                           ' switching to ' +
                           (location ? location.spec : null) +
                           ' for ' + sReason);
        this.fSetAvailability(!!sitemapURI);
        if (sitemapURI) {
            var sitemapKey = sitemapURI;

            this.lib.xulRemoveClass(this.rootElem, 'empty');
            this.sourceButton1.setAttribute('disabled', false);
            this.sourceButton2.setAttribute('disabled', false);
            this.whereAmIButton.setAttribute('disabled', false);

            if (sReason != "location-change" &&
                sReason != "in-site-change" &&
                (bForceChange || !this.recoverTreeFromHistory(sitemapURI))) {
                // Initiate an update of the sitemap data.
                var func = function(sitemap) {
                    self.SitemapLoaded(sitemap);
                };
                this.oAgent.getSitemap(func);
            } else {
                // Highlight the appropriate items in the sidebar,
                // with respect to the current location.
                this.processCurrentPage();

                // Record the state of the tree in the history.
                if (sReason != "location-change")
                    this.saveTreeInHistory();
            }

            var bDefaultOpen = bAutoOpen;

            // If the sidebar is visible, tell the agent that we are
            // displaying the sitemap.
            this.updateDisplayLevel();
        } else {
            var sitemapKey = this.lib.makeURI('null:');

            this.lib.xulAddClass(this.rootElem, 'empty');
            this.sourceButton1.setAttribute('disabled', true);
            this.sourceButton2.setAttribute('disabled', true);
            this.whereAmIButton.setAttribute('disabled', true);

            var bDefaultOpen = bAutoOpen || sReason == 'init';
        }

        // Ensure the sidebar is visible, according to preference.
        this.setVisibility(this.getVisibilityPref(sitemapKey, bDefaultOpen));

        // Restore the sidebar width for the current sitemap.
        var sWidth = this.getSitePref(sitemapKey, 'sidebarwidth');
        if (!sWidth)
            sWidth = 180;
        this.oPanel.mStandardSitemapBox.width = sWidth;

        // Make sure we don't keep rebuilding the tree.
        this.lastSitemapURI = sitemapURI ? sitemapURI.clone() : null;
    },

    updateDisplayLevel : function() {
        this.oAgent.setDisplayLevel('sidebar', this.bVisible ? 50 :
                                    (this.oSitemapURI ? 25 : 0));
    },

    sitemapPrefObserver :
    {
        /* Observer pref change events, notified from SSLib */
        observe : function(subject, topic, data)
        {
            if (topic == "standard-sitemap-prefchanged")
            {
                setTimeout(function() {SitemapSidebar.UpdateVisualSettings();}, 250);
            }
        }
    },
    
    
    onUnload : function(event) {
        if (this.browser.sessionHistory)
            this.browser.sessionHistory
            .removeSHistoryListener(this.historyListener);
        this.removeListener();
    },

    
    /* Reload the sitemap*/
    ReloadSitemap: function(oEvent)
    {
        this.lastSitemapURI = null;
        this.oAgent.invalidateSitemap(true, oEvent && oEvent.ctrlKey);
        this.oAgent.informListeners('sidebar-force-reload');
    },

    /*Callback function called from the StandardSitemap when the document has finished loading.*/
    SitemapLoaded: function(oLoadedSitemap)
    {
        this.oSitemap = oLoadedSitemap;
        this.displaySitemap();
        this.processCurrentPage();
        this.saveTreeInHistory();
        //this.whereAmI(null, true);
    },

    //TODO: Do we need this? Firefox's open file does the same thing for us
    loadLocalSitemap : function() {
        var localFile = this.lib.filePicker(arguments[0]);
        if (localFile) {
            this.browser.contentDocument.location = localFile.fileURI.spec;
        }
    },
    
    //Just a central place to enable/disable/hide/show buttons and stuff
    UpdateVisualSettings: function()
    {
        // This has happened rarely when a tab is dragged out as a new
        // window.
        if (!document)
            return;

        //Check for Webmaster mode:
        if (this.lib.getBoolPref("modeWebmaster")) {
            document.getElementById("bottomtoolbarseparator").hidden = false;
            document.getElementById("opensitemap-button").hidden = false;
            document.getElementById("sourcecode1-button").hidden = false;
            document.getElementById("sourcecode2-button").hidden = false;
            
        }
        else
        {
            document.getElementById("bottomtoolbarseparator").hidden = true;
            document.getElementById("opensitemap-button").hidden = true;
            document.getElementById("sourcecode1-button").hidden = true;
            document.getElementById("sourcecode2-button").hidden = true;
        }
        //Check for visitonselect mode:
        if (this.lib.getBoolPref("visitonselect") &&
            this.lib.getBoolPref("selectonvisit")) {
            document.getElementById("whereami-button").hidden = true;
        }
        else
        {
            document.getElementById("whereami-button").hidden = false;
        }
        //Check for showUpButton mode:
        if (this.lib.getBoolPref("showUpButton")) {
            document.getElementById("up-button").hidden = false;
        }
        else
        {
            document.getElementById("up-button").hidden = true;
        }
    },

    /*Handles focus change to remove/add the search label*/
    HandleSearchFocus: function(bGotFocus)
    {
        this.searchBox.childNodes[0].setAttribute("hasfocus", bGotFocus);
        if (!this.oSitemap)
            return;

        var oTextbox = document.getElementById('search-term');
        if (bGotFocus)
        {
            if (oTextbox.value ==
                this.oSitemap.oSearch.getName(this.preferedLanguages))
                oTextbox.value = "";
        }
        else
        {
            if (!oTextbox.value || oTextbox.value == "") {
                oTextbox.value =
                    this.oSitemap.oSearch.getName(this.preferedLanguages);
            }
        }
    },
    
    /*Handles key presses in the search textbox*/
    HandleSearchKey: function(oEvent)
    {
        if (oEvent.keyCode == 13) return this.search(oEvent);
        if (oEvent.keyCode == 27)
        {
            document.getElementById('search-term').value = "";
        }
    },
    
    search : function(event)
    {
        if (!this.oSitemap.oSearch) return;
        
        var mSearch = this.oSitemap.oSearch.get(this.preferedLanguages);
        var sInput = document.getElementById('search-term').value;

        if (!sInput || sInput == "" || sInput == this.oSitemap.oSearch.getName(this.preferedLanguages)) return; //Don't search for the label or empty strings.


        // Insert the search term into the query string.
        var sReplacedData = mSearch['searchdata'];
        if (!sReplacedData)
            return;
        sReplacedData = this.oSitemap.ReplaceFields(sReplacedData, sInput);

        var sMethod = mSearch['method'];
        if (sMethod && sMethod.toLowerCase() == "post") {
            // POST method requests must wrap the encoded text in a MIME stream
            var oStringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
            oStringStream.data = sReplacedData;

            var oPostData = Components.classes["@mozilla.org/network/mime-input-stream;1"].createInstance(Components.interfaces.nsIMIMEInputStream);
            oPostData.addHeader("Content-Type", "application/x-www-form-urlencoded");
            oPostData.addContentLength = true;
            oPostData.setData(oStringStream);

            window.top.openUILink(mSearch['addr'].spec, event,
                                  false, false, false, oPostData);
        } else {
            var sURI = mSearch['addr'].resolve('?' + sReplacedData);

            /*Store a reference to this sitemap on the overlay so we can use that while on google.com*/
            if (this.oSitemap.bIsGoogleSiteSearch)
            {
                window.top.openUILink(sURI, event, false, false, false, null, this.oSitemap.oSitemapURI);
            }
            else
            {            
                window.top.openUILink(sURI, event);
            }
        }
        
        /*Store the original query in the search history*/
        this.SaveSearchHistory(sInput);
    },

    SaveSearchHistory: function(sValue)
    {
            if (sValue != "")
            {
                    var oFormHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory2);
                    oFormHistory.addEntry("searchbar-history", sValue);
            }
    },
    
    
    visitSource : function() {
        var loc = this.oAgent.getSitemapURI();
        if (!loc)
            return;
        window.content.location = loc.spec;
    },
    
    viewSource: function()
    {
        var loc = this.oAgent.getSitemapURI();
        if (!loc)
            return;
        top.gViewSourceUtils.openInInternalViewer(loc.spec);
    },

    setToolbarPosition : function(idealName, orient) {
        var idealContainer = document.getElementById(idealName);
        var toolbar = document.getElementById('sitemap-toolbar');
        var currentContainer = toolbar.parentNode;
        if (currentContainer == idealContainer) {
            return;
        }
        currentContainer.removeChild(toolbar);
        idealContainer.appendChild(toolbar);
        toolbar.setAttribute('orient', orient);
    },

    setVerticalToolbar : function() {
        this.setToolbarPosition('vbar-container', 'vertical');
    },

    setHorizontalToolbar : function() {
        this.setToolbarPosition('hbar-container', 'horizontal');
    },

    /* Create a treeview using the data in the StandardSitemap*/
    displaySitemap : function() {
        this.treeItemList = [];

        //Clear the tree
        this.lib.xulRemoveAllChildren(this.tree.firstChild.nextSibling);

        if (!this.oSitemap) return;
        //Update visibility of buttons and stuff.
        //this.UpdateVisualSettings();

        this.updateSearchBox();
        this.populateRoleButtons();


        /*ToDo: Should only check the language on the first node?
          We could check it per item but that would be slower,
          and might result in a mixed language tree if the webmaster made an error in his/her sitemap.
        */
//         this.sSelectedLanguage = '';
//         var iIndex, iLen = this.preferedLanguages.length;
//         for (iIndex = 0; iIndex < iLen; iIndex ++)
//         {
//             if (this.oSitemap.oSitemapNode.aChildNodes[0].SupportsLanguage(this.preferedLanguages[iIndex])) {
//                 this.sSelectedLanguage = this.preferedLanguages[iIndex];
//                 //Stop at the first found, the accept_languages setting holds languages in order of preference.
//                 break;
//             }
//         }

        //Start looping the sitemap data.
        this.addChildren(this.tree.firstChild.nextSibling, this.oSitemap.oSitemapNode, true);
        
        //Remove touching borders.
        this.ProcessTouchingGroupBorders();
    },

    /*Parent is the treeview control where the items should be added. sourceNode is the oSitemapNode element whose children are to be iterated through.*/
    addChildren : function(parent, sourceNode, bRootLoop) {
        var treeItem;
        for (var i = 0; i < sourceNode.aChildNodes.length; i++)
        {
            treeItem = this.addItem(parent, sourceNode,
                                    sourceNode.aChildNodes[i]);
        }
        if (bRootLoop && sourceNode.aChildNodes.length == 1 && treeItem)
        {
            treeItem.setAttribute('open', true);
        }
    },
    
    /*Adds a new treeview item*/
    addItem : function(parent, sourceParent, item) {
        var content = item.GetContent(this.preferedLanguages);

        // Eliminate loops.  Check to see if any ancestor in the GUI
        // tree already represents this item.
        for (var ancestor = parent.parentNode;
             ancestor && ancestor.sourceNode != item;
             ancestor = ancestor.parentTreeItem) {
        }
        if (ancestor) return;

        var treeItem;
        var itemName = content['name'];

        if (!item.bIsGroup || itemName)
        {
            treeItem = document.getElementById('treeItemTemplate').cloneNode(true);

            // Make sure we can detect loops.
            treeItem.sourceNode = item;

            treeItem.parentTreeItem = parent.parentNode.tagName == 'treeitem' ? parent.parentNode : null;
            treeItem.row = treeItem.firstChild;
            treeItem.cell = treeItem.row.firstChild.nextSibling;
            treeItem.whereami = treeItem.row.firstChild;
            treeItem.snchildren = treeItem.row.nextSibling;

            treeItem.setAttribute('id', item.sID);
            treeItem.setAttribute('hidden', '');

            if (false) {
                var itemUrl = content['addr'];
                var itemDescription = content['desc'];
                var bVisited = this.lib.isVisitied(itemUrl);
                itemUrl = itemUrl ? itemUrl.spec : null;

                treeItem.cell.setAttribute('label', itemName);
                var sTooltip = itemName.replace('\\s+', ' ');
                if (itemDescription)
                    sTooltip += '\n' + itemDescription.replace('\\s+', ' ');
                treeItem.cell.setAttribute('tooltiptext', sTooltip);


                if (itemUrl) {
                    treeItem.url = itemUrl;
                    treeItem.cell.setAttribute('properties',
                                               treeItem.cell.getAttribute('properties') + ' treeItemLink');
                    if (bVisited) treeItem.cell.setAttribute('properties', treeItem.cell.getAttribute('properties') + ' visited');
                    treeItem.row.setAttribute('properties', treeItem.row.getAttribute('properties') + ' treeItemLink');
                }
            } else {
                this.updateLanguageContentInItem(treeItem, item,
                                                 content, itemName);
            }

            treeItem.relation = item.sRelation;
            treeItem.listPosition = this.treeItemList.length;
            this.treeItemList.push(treeItem);
            if (!item.HasChildren) {
                treeItem.removeChild(treeItem.snchildren);
                treeItem.snchildren = null;
            } else {
                //<item>'s are closed by default, <group>'s are open.
                if (!item.bIsGroup) {
                    treeItem.setAttribute('open', false);
                } else {
                    treeItem.setAttribute('open', true);
                }
                treeItem.cell.setAttribute('properties', 'treeItemParent');
            }
            
            treeItem.cell.setAttribute('properties', treeItem.cell.getAttribute('properties') + ' bold' + item.iPriority);
            if (sourceParent.bIsGroup || item.bIsGroup)
            {
                if (sourceParent.bIsGroup && !sourceParent.GetName(this.preferedLanguages))
                {
                    //Grouped Items where the parent is not shown (but is available in the StandardSitemapNode structure).
                    if (sourceParent.HasChildren) 
                    {
                        if (sourceParent.FirstChild.sID == item.sID)
                        {
                            treeItem.row.setAttribute('properties', treeItem.row.getAttribute('properties') + ' firstingroup');
                        }
                        if (sourceParent.LastChild.sID == item.sID)
                        {
                            treeItem.row.setAttribute('properties', treeItem.row.getAttribute('properties') + ' lastingroup');
                        }
                    }
                }
                else
                {
                    //Grouped Items where the parent is shown.
                    if (item.bIsGroup)
                    {
                        treeItem.row.setAttribute('properties', treeItem.row.getAttribute('properties') + ' firstingroup');
                    }
                    if (sourceParent.HasChildren && sourceParent.LastChild.sID == item.sID && !item.bIsGroup)
                    {
                        treeItem.row.setAttribute('properties', treeItem.row.getAttribute('properties') + ' lastingroup');
                    }
                }
                if (item.bIsGroup)
                {
                    treeItem.cell.setAttribute('properties', treeItem.cell.getAttribute('properties') + ' group');
                    treeItem.row.setAttribute('properties', treeItem.row.getAttribute('properties') + ' group');
                }
            }
        }
        else
        {
            if (!parent)
            {
                treeItem = this.tree.firstChild.nextSibling;
                treeItem.parentTreeItem = null;
                treeItem.row = treeItem.firstChild;
                treeItem.cell = treeItem.row.firstChild.nextSibling;
                treeItem.whereami = treeItem.row.firstChild;
                treeItem.snchildren = treeItem;
            }
            else
            {
                treeItem = parent;
                treeItem.snchildren = treeItem;
            }
        }

        this.addChildren(treeItem.snchildren, item, false);

        if (!item.bIsGroup || item.GetName(this.sSelectedLanguage))
        {
            parent.appendChild(treeItem);
        }
        return treeItem;
    },
    
    /* Removes occurences where a bottom and top "touch" each other*/
    ProcessTouchingGroupBorders: function()
    {
        var sProperties;
        var iIndex, iLen = this.treeItemList.length;
        for (iIndex = 0; iIndex < iLen; iIndex ++)
        {
            sProperties = this.treeItemList[iIndex].row.getAttribute('properties');
            if (iIndex == 0) sProperties = sProperties.replace("firstingroup", "");
            if (iIndex == (iLen - 1)) sProperties = sProperties.replace("lastingroup", "");
            if (iIndex < (iLen - 1))
            {
                if (sProperties.indexOf("lastingroup") >= 0 && this.treeItemList[iIndex + 1].row.getAttribute('properties').indexOf("firstingroup") >= 0)
                {
                    sProperties = sProperties.replace("lastingroup", "");
                }
            }
            this.treeItemList[iIndex].row.setAttribute('properties', sProperties);
        }
    },

    /* Highlights the current page in the site tree and
     * opens all nodes leading to it.
     */
    processCurrentPage : function() {
        if (!this.oSitemap)
            return;

        var self = this;

        var url = this.oAgent.getLocation();
        if (url)
            url = url.spec;

        this.updateHighlightingTo(url);

        // Handle sequences.
        var prev = [], next = [];
        var mUp = this.lib.newMap();
        var prefLangs = this.preferedLanguages;
        var aNodes = this.oSitemap.GetNodesForURI(url);
        //this.lib.dump('Matching nodes against ' + window.content.location.href);
        for (var i in aNodes) {
            var oNode = aNodes[i];
            oNode.mParent.foreach(function(oParentNode) {
                mUp.put(oParentNode, true);
            });

//             this.lib.dump('Found node ' + oNode.GetName(prefLangs));
            oNode.mPrev.foreach(function(oParentNode, oPreviousNode) {
//                 self.lib.dump('Prev: ' +
//                        (oPreviousNode ? oPreviousNode.GetName() : "null") +
//                        ' under ' + oParentNode.GetName());
                if (!oPreviousNode)
                    return;
                prev.push({
                    parent : oParentNode,
                    sibling : oPreviousNode,
                    sequence : (oParentNode.sRelation == "sequence")
                });
            });
            oNode.mNext.foreach(function(oParentNode, oNextNode) {
//                 self.lib.dump('Next: ' +
//                        (oNextNode ? oNextNode.GetName() : "null") +
//                        ' under ' + oParentNode.GetName());
                if (!oNextNode)
                    return;
                next.push({
                    parent : oParentNode,
                    sibling : oNextNode,
                    sequence : (oParentNode.sRelation == "sequence")
                });
            });
        }

        var up = [];
        mUp.foreach(function(oParentNode) {
            up.push({ parent : oParentNode });
        });


        this.removeLink(document.getElementById('up-button'));
        this.removeLink(document.getElementById('next-button'));
        this.removeLink(document.getElementById('previous-button'));

        this.updateLanguageDisplay();

        this.setSequenceMenu(document.getElementById('previous-button'),
                             'previous-popup',
                             document.getElementById('previous-popup'), prev,
                             'sibling', true);
        this.setSequenceMenu(document.getElementById('next-button'),
                             'next-popup',
                             document.getElementById('next-popup'), next,
                             'sibling', true);
        this.setSequenceMenu(document.getElementById('up-button'),
                             'up-popup',
                             document.getElementById('up-popup'), up,
                             'parent');

        if (url) {
            // Find the first item that matches the current location.
            for (var i = 0; i < this.treeItemList.length; i++) {
                var treeItem = this.treeItemList[i];
                if (url == treeItem.url)
                    break;
            }
            if (i == this.treeItemList.length)
                treeItem = null;

            if (!treeItem) {
                // No exact match found, so look for an item matching the
                // current location with the #hash part chopped off.
                var choppedurl = url.split("#")[0];
                for (var i = 0; i < this.treeItemList.length; i++) {
                    var treeItem = this.treeItemList[i];
                    if (choppedurl == treeItem.url)
                        break;
                }
            }
            if (i == this.treeItemList.length)
                treeItem = null;

            var bFindOnVisit = this.lib.getBoolPref("findonvisit");
            var bOpenOnVisit = this.lib.getBoolPref("openonvisit");
            var bSelectOnVisit = this.lib.getBoolPref("selectonvisit");

            if (treeItem && (bFindOnVisit || bSelectOnVisit || bOpenOnVisit)) {
                // Open up all parent items of the selected item.
                for (var parent = bOpenOnVisit ?
                     treeItem : treeItem.parentTreeItem;
                     parent != null; parent = parent.parentTreeItem)
                    parent.setAttribute('open', true);

                if (bSelectOnVisit) {
                    var viewIndex = this.tree.view.getIndexOfItem(treeItem);
                    if (viewIndex >= 0)
                        this.tree.view.selection.select(viewIndex);
                }
            }
        }
    },

    setLatestParent : function(node) {
        if (!node) return;
        //this.lib.dump('Latest parent is ' + node.GetName());
        this.latestSequenceParent = node;
    },

    visitAndRecordParent : function(window, sidebar, url, parent) {
        var self = this;
        return function() {
            self.lib.dump("Visiting <" + url + ">");
            window.top.content.location = url;
            sidebar.setLatestParent(parent);
        };
    },

    latestSequenceParent : null,

    setSequenceMenu : function(button, name, element, aNodes, sField,
                               sequenceOnly) {
        if (!name || aNodes.length == 0) {
            button.removeAttribute('context');
            this.lib.xulDisable(button);
            return;
        }

        // Clear all previous items.
        this.lib.xulRemoveAllChildren(element);

        var uri1, uri2;
        var currentChildUri;
        var count = 0;

        // Add new items.
        for (var i in aNodes) {
            var data = aNodes[i];

            // Eliminate items that didn't come from sequences.
            if (sequenceOnly && !data.sequence)
                continue;

            // Eliminate items that don't have addresses.
            var uri = data[sField].GetURI(this.sSelectedLanguage);
            if (!uri)
                continue;
            uri = uri.spec;

            if (!uri1)
                uri1 = uri;
            else if (!uri2)
                uri2 = uri;

            // Eliminate items whose parents don't have any text to
            // display.
            var label = data.parent.GetName(this.sSelectedLanguage);
            // Use the description as a back-up?
            if (!label)
                label = data.parent.GetDescription(this.sSelectedLanguage);
            if (!label)
                continue;

            // Identify the child of the parent of the last item
            // clicked.
            if (this.latestSequenceParent == data.parent)
                currentChildUri = uri;

            // Create a menu item for this relative.
            var item = document.createElement('menuitem', this.lib.xulNS);
            item.setAttribute('label', label);
            var tooltip = data[sField].GetName(this.sSelectedLanguage);
            if (tooltip)
                item.setAttribute('tooltip', tooltip);
            item.onclick =
                this.visitAndRecordParent(window, this, uri, data.parent);
            element.appendChild(item);

            // Count the items that appear in the menu.
            count++;
        }

        // Does a direct click on the button take us anywhere?
        if (uri1 && !uri2) {
            // There is exactly one choice of valid URI.  Make the button
            // go to it directly.
            this.createLink(button, uri1, false);
            button.removeAttribute('popup');
            //this.lib.dump('defaulted ' + name + ' button to ' + uri1);
        } else if (currentChildUri) {
            // We found an item which is the child of the parent of
            // the last item clicked.
            this.createLink(button, currentChildUri, false);
            button.removeAttribute('popup');
        } else {
            // There is more than one parent, and we don't know
            // which one is preferred.  Make the button click pop
            // up the context menu.
            this.removeLink(button);
            //this.lib.dump('must make a selection on ' + name);
            if (count > 0)
                button.setAttribute('popup', name);
        }

        // Do we enable the context menu?
        if (count > 0) {
            // A menu should pop up.
            //this.lib.dump('enabled ' + name);
            button.setAttribute('context', name);
            this.lib.xulEnable(button);
        } else {
            // There are no menu items, so don't pop up the context menu.
            //this.lib.dump('disabled ' + name);
            this.lib.xulRemoveAllChildren(element);
            button.removeAttribute('context');
        }
    },

    /* Creates links for the <- and -> buttons if the
     * current url is part of a sequence.
     */
    createSequenceLinks : function(treeItem) {

        if (treeItem.parentTreeItem && treeItem.parentTreeItem.relation == 'sequence') {
            if (treeItem.nextSibling) {
                this.createLink(document.getElementById('next-button'), treeItem.nextSibling.url, false);
            }
            if (treeItem.previousSibling) {
                this.createLink(document.getElementById('previous-button'), treeItem.previousSibling.url, false);
            }
        }
    },


    /* Turns an element into a link to the given url.
     * The url will be shown in statusbar when hovering
     * over the element and the element will be enabled.
     */
    createLink : function(element, url, useHandPointer) {
        var self = this;
        var fullUrl = url; // Assume it is already resolved.

        element.onclick = function(event) {
            if (event.button == 0) window.content.document.location = fullUrl;
        };

        element.url = fullUrl;

        element.setAttribute('statustext', fullUrl ? fullUrl : "");
        element.onmouseover = function() {
            self.lib.setStatusBarText(element, window);
        };
        element.onmouseout = function() {
            self.lib.clearStatusBarText(window);
        };
        if (useHandPointer) {
            this.lib.xulAddClass(element, 'link');
        }

        this.lib.xulEnable(element);
    },

    /* Inverse of createLink. Removes everything that makes
     * the element behave like a link.
     */
    removeLink : function(element) {

        element.url = null;
        element.onclick = null;
        element.onmouseover = null;
        element.onmouseout = null;
        element.setAttribute('statustext', '');
        this.lib.xulRemoveClass(element, 'link');
        this.lib.xulDisable(element);
    },

    /* When page doesn't have a sitemap,
     * disable all the buttons and remove their onclick attributes
     * and distroy everything in it's path
     */
    disableButtons : function() {
        var buttontoolbar = document.getElementById('sitemap-toolbar');
        for(var i = 0; i < buttontoolbar.childNodes.length; i++) {
            var curChildnode= buttontoolbar.childNodes[i];
            if (curChildnode.tagName == "toolbarbutton") {
                this.removeLink(curChildnode); //TODO: Maybe exclude lang and file format when they're implemented?
            }
        }
    },

    /* Visit a specified item. */
    visitItem : function(item, bKeepFocus) {
        if (!item || !item.url)
            return;

        if (item.parentTreeItem)
            this.setLatestParent(item.parentTreeItem.sourceNode);

        if (this.browser.currentURI.equals(this.lib.makeURI(item.url)))
            return;

        this.lib.dump("Visiting item <" + item.url + ">");
        var referrerOption = this.lib.getCharPref('referrer');
        var referrer = null;
        if (referrerOption == 'sitemap') {
            referrer = this.oAgent.getSitemapURI();
        } else if (referrerOption == 'current') {
            referrer = this.oAgent.getLocation();
        }
        this.browser.loadURI(item.url, referrer);

        // TODO: Disable this if we know the visit was due to a
        // keypress in the sidebar?
        if (!bKeepFocus)
            this.browser.contentWindow.focus();
    },

    /* Visit the currently selected item. */
    visitCurrentItem : function(bKeepFocus) {
        if (this.tree.currentIndex >= 0)
        {
            var item = this.tree.view.getItemAtIndex(this.tree.currentIndex);
            this.visitItem(item, bKeepFocus);
        }
    },

    /* When user selects tree item we load the url, unless it's already loaded. */
    treeSelect : function(event) {
        if (!this.lib.getBoolPref("visitonselect"))
            return false;
        var loc = this.oAgent.getSitemapURI();
        this.lib.debug('Select item ' + this.tree.currentIndex + ' in ' +
                       (loc ? loc.spec : null));
        this.visitCurrentItem(true);
        return false;
    },

    /* Figures out if the cursor is over a tree item with an url and displays
     * the url in the statusbar
     */
    treeMouseMove : function(event) {
        if (!this.treeMouseMove.originalStatusBarText) {
            this.treeMouseMove.originalStatusBarText =
                this.lib.getStatusBarText(window);
        }

        var oCoords = {};
        if (this.IdentifyTreeItem(event, oCoords)) {
            // The pointer is over an item.
            var item = oCoords.item;
            if (item.url) {
                this.lib.setStatusBarText(item.url, window);
            } else {
                this.lib.setStatusBarText
                (this.treeMouseMove.originalStatusBarText, window);
            }
        } else {
            // The pointer is not over an item.
            this.lib.setStatusBarText(this.treeMouseMove.originalStatusBarText,
                                      window);
        }

        return false;
    },
    
    /* Expands non clickable (parent) items on click
     */
    treeClick : function(event) {
        var row = {}, column = {}, part = {};
        var boxobject = this.tree.boxObject;
        boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
        boxobject.getCellAt(event.clientX, event.clientY, row, column, part);
        if (row.value != -1)
        {
            var item = this.tree.view.getItemAtIndex(row.value);
            if (!item.url && event.button != 2 && part.value != "twisty") {
                item.setAttribute('open', item.getAttribute('open') != "true");
                return false;
            }

            // If selection doesn't trigger a visit, we have to be
            // sure that a click will.  Should not occur when clicked
            // on the twisty, or when the menu button is clicked.
            if ((!this.lib.getBoolPref("visitonselect") &&
                 part.value != "twisty" &&
                 event.button != 2) || event.button == 1)
            {
                item.cell.setAttribute('properties', item.cell.getAttribute('properties') + ' visited');
                if (event.button == 1) {
                    // 'Middle' click, so open in new tab/window.
                    window.top.openUILink(item.url, event);
                } else if (event.ctrlKey &&
                           !!this.lib.getBoolPref("ctrlfornewtab")) {
                    window.top.openNewTabWith(item.url, null, null, event);
                } else if (event.shiftKey) {
                    window.top.openNewWindowWith(item.url);
                } else {
                    this.visitItem(item,
                                   !!event.ctrlKey ^
                                   !!this.lib
                                   .getBoolPref("invertctrlforfocus"));

                    if (this.lib.getBoolPref('openonclick'))
                        item.setAttribute('open', "true");
                }
            }
        }
        return false;
    },
    
    /* Prevent group headers to be expanded/collapsed by double clicking */
    treeDoubleClick: function(event)
    {
        if (this.tree.currentIndex >= 0)
        {
            var item = this.tree.view.getItemAtIndex(this.tree.currentIndex);
            if (item)
            {
                if (item.firstChild.firstChild.getAttribute("properties").indexOf("group") >= 0)
                {
                    item.setAttribute('open', "true");
                }
            }
        }
        return false;
    },

    /* Visits the currently selected item if Return is pressed. */
    treePress : function(event) {
        if (event.keyCode != 13)
            return true;
        this.visitCurrentItem(!!event.ctrlKey ^
                              !!this.lib.getBoolPref("invertctrlforfocus"));
        return false;
    },

    IdentifyTreeItem : function(oEvent, oCoords) {
        var oTreeBox = this.tree.boxObject;

        var iTargetX = oEvent.clientX;
        var iTargetY = oEvent.clientY;

        var oRow = {}, oColumn = {}, oPart = {};
        oTreeBox.QueryInterface(Components.interfaces.nsITreeBoxObject);
        oTreeBox.getCellAt(iTargetX, iTargetY, oRow, oColumn, oPart);

        if (false)
            this.lib.debug("x=" + iTargetX + " y=" + iTargetY +
                           " row=" + oRow.value);

        oCoords.row = oRow.value;
        oCoords.column = oColumn.value;
        oCoords.part = oPart.value;
        if (oRow.value == -1)
            return false;
        oCoords.item = this.tree.view.getItemAtIndex(oRow.value);
        return true;
    },

    OpenLinkIn : function(oEvent, where) {
        if (!this.lastMenuCoords || !this.lastMenuCoords.item)
            return;

        var oItem = this.lastMenuCoords.item;
        if (!oItem.url)
            return;
        if (where == "window") window.top.openNewWindowWith(oItem.url);
        if (where == "tab") window.top.openNewTabWith(oItem.url);
        //window.top.openUILinkIn(oItem.url, where); //This one listens to the loadBookmarksInBackground pref, not loadInBackground
    },
    
    BookmarkLink: function(oEvent)
    {
        if (!this.lastMenuCoords || !this.lastMenuCoords.item)
            return;

        var oItem = this.lastMenuCoords.item;
        if (!oItem.url)
            return;
        window.top.PlacesCommandHook.bookmarkLink(window.top.PlacesUtils.bookmarksMenuFolderId, oItem.url, oItem.cell.getAttribute('label'));
    },
    
    SendLink: function(oEvent)
    {
        if (!this.lastMenuCoords || !this.lastMenuCoords.item)
            return;

        var oItem = this.lastMenuCoords.item;
        if (!oItem.url)
            return;
        window.top.MailIntegration.sendMessage(oItem.url, oItem.cell.getAttribute('label'));
    },
   
    SaveLink: function(oEvent)
    {
        if (!this.lastMenuCoords || !this.lastMenuCoords.item)
            return;

        var oItem = this.lastMenuCoords.item;
        if (!oItem.url)
            return;
        window.top.saveURL(oItem.url, null, null, true);
    },
    
    ShowProperties: function(oEvent)
    {
        if (!this.lastMenuCoords || !this.lastMenuCoords.item)
            return;

        var oItem = this.lastMenuCoords.item;
            
        var oLink = window.top.getBrowser().contentDocument.createElement('A');
        oLink.setAttribute('href', oItem.url);
        oLink.setAttribute('title', oItem.cell.getAttribute('label'));
        window.openDialog("chrome://browser/content/metaData.xul", "_blank", "scrollbars,resizable,chrome,dialog=no",oLink);    
    },

    // Check if we should show the context menu, and record the item
    // which it deals with.
    PreCopyTreeData: function(oEvent, oPopup)
    {
        var oCoords = {};
        if (this.IdentifyTreeItem(oEvent, oCoords)) {
            this.lastMenuCoords = oCoords;
            this.lib.debug('Item: ' + oCoords.item.cell.getAttribute('label'));
            oCoords.content =
                oCoords.item.sourceNode.GetContent(this.preferedLanguages);
        } else {
            this.lastMenuCoords = oCoords = null;
        }
        var menuitems = oPopup.getElementsByTagName('menuitem');
        for (var i = 0; i < menuitems.length; i++) {
            var elem = menuitems[i];
            var classes = elem.getAttribute('class').trim().split(/\s+/);
            var keep = true;

            for each (var cl in classes) {
                if ("item" == cl && (!oCoords || !oCoords.item)) {
                    keep = false;
                    break;
                }
                if ("addr" == cl &&
                    (!oCoords || !oCoords.item || !oCoords.item.url)) {
                    keep = false;
                    break;
                }
                if ("name" == cl &&
                    (!oCoords || !oCoords.content['name'])) {
                    keep = false;
                    break;
                }
                if ("desc" == cl &&
                    (!oCoords || !oCoords.content['desc'])) {
                    keep = false;
                    break;
                }
            }

            elem.setAttribute('disabled', !keep);
        }
        return false;
    },

    //Copies data from the current tree item to the clipboard
    CopyTreeData: function(oEvent, copytype)
    {
        if (!this.lastMenuCoords || !this.lastMenuCoords.item)
            return;

        var oItem = this.lastMenuCoords.item;
        var sText = "";
        if (copytype == "name")
            sText = this.lastMenuCoords.content['name'];
        else if (copytype == "description")
            sText = this.lastMenuCoords.content['desc'];
        else if (copytype == "address")
            sText = oItem.url;

        if (sText != "")
        {
            Components.classes['@mozilla.org/widget/clipboardhelper;1'].getService(Components.interfaces.nsIClipboardHelper).copyString(sText);
        }
    },

    /*Check if the tooltip is over a tree item, and update the tooltip text*/
    ProcessTooltip: function(oEvent, oTooltip)
    {
        var oCoords = {};
        if (!this.IdentifyTreeItem(oEvent, oCoords))
            return false;
        var oItem = oCoords.item;

        var sTooltip = oItem.cell.getAttribute('tooltiptext');
        if (!sTooltip || sTooltip == "") return false; //No tooltip

        oTooltip.setAttribute("label", sTooltip);
        return true;    
    },

    whereAmI : function(event, bIgnorePageFirst) {
        // TODO: Drop the event argument.  It's not actually used.

        if (!this.tree.view) {
            this.lib.debug('no view for ' + this.panelId);
            return;
        }

        // What URL are we seeking?
        var target = this.oAgent.getLocation();

        if (!target) return;
        target = target.spec;

        // What is that without a fragment identifier?
        var targetPage = target.indexOf('#');
        if (targetPage < 0) {
            targetPage = target;
        } else {
            targetPage = target.substring(0, targetPage);
        }

        // Which is the current item?
        if (this.tree.currentIndex < 0) {
            // There is none.  Start at the end!
            var inum = 0;
        } else {
            var item = this.tree.view.getItemAtIndex(this.tree.currentIndex);

            // Which item is that, numerically?
            var inum = item.listPosition;
        }

        // Try to find the next item with the same URL.
        for (var i = 0; i < this.treeItemList.length; i++) {
            var current =
                this.treeItemList[(i + inum + 1)
                                  % this.treeItemList.length].url;
            if (!current)
                continue;
            if (current == target ||
                (current == targetPage && !bIgnorePageFirst))
                break;
        }
        if (i == this.treeItemList.length) {
            // None was found.

            if (bIgnorePageFirst) {
                // Try again, but include coarse page matches.
                this.whereAmI(event);
            } else {
                // Show that none was found by deselecting everything.
                this.tree.view.selection.select(-1);
            }
        } else {
            // Move to that item.  (Might be the same one.)
            inum += i + 1;
            inum %= this.treeItemList.length;
            this.selectItem(this.treeItemList[inum]);
        }
    },

    selectItem : function(treeItem) {
        // Open all parent nodes.
        var parent = treeItem.parentTreeItem;
        while (parent) {
            parent.setAttribute('open', true);
            parent = parent.parentTreeItem;
        }

        var viewIndex = this.tree.view.getIndexOfItem(treeItem);
        this.tree.view.selection.clearSelection();
        this.tree.view.selection.select(viewIndex);
        this.tree.treeBoxObject.ensureRowIsVisible(viewIndex);
    },

    // Go through all items, and highlight them if and only if they
    // refer to the current page.
    //
    // TODO: To cope with large trees, place all items in a map from
    // URL to item[], and look-up the ones to be highlighted.  Also
    // keep a record of the previous URL so the old ones can be
    // switched off.
    updateHighlightingTo : function(target) {
        var targetPage = target ? target.split('#')[0] : null;

        for (var i = 0; i < this.treeItemList.length; i++) {
            var item = this.treeItemList[i];
            this.lib.xulRemoveProperty(item.cell, "containsVisiting");
            if (item.url == target || item.url == targetPage) {
                this.lib.xulAddProperty(item.cell, 'visiting');
                this.lib.xulAddProperty(item.whereami,'visitingBong');
                var parent = item.parentTreeItem;
                while (parent) {
                    this.lib.xulAddProperty(parent.cell, "containsVisiting");
                    parent = parent.parentTreeItem;
                }
            } else {
                this.lib.xulRemoveProperty(item.cell, 'visiting');
                this.lib.xulRemoveProperty(item.whereami, 'visitingBong');
            }
        }

        if (this.oSitemap) {
            // Go through certain toolbar buttons to check whether
            // we're visiting them.
            var mButtons = {
                'snhome-button' : this.oSitemap.oHome,
                'contact-button' : this.oSitemap.oContact,
                'contentinfo-button' : this.oSitemap.oContentInfo
            };
            for (var id in mButtons) {
                var oItem = mButtons[id];
                if (oItem) {
                    var sAddr = oItem.getAddress(this.preferedLanguages).spec;
                    var bMatch = sAddr == target || sAddr == targetPage;
                } else
                    var bMatch = false;
                this.updateToolbarHighlighting(document.getElementById(id), bMatch);
            }
        }
    },

    updateToolbarHighlighting : function(sButton, bState) {
        if (bState)
            this.lib.xulAddClass(sButton, 'here');
        else
            this.lib.xulRemoveClass(sButton, 'here');
    },

    /*Store the new width of this sidebar in the sitemap object*/
    HandleSidebarResize: function(oEvent)
    {
        var oSitemapURI = this.oAgent.getSitemapURI();
        if (!oSitemapURI)
            oSitemapURI = this.lib.makeURI('null:');
        var iWidth = this.rootElem.boxObject.width;
        this.setSitePref(oSitemapURI, 'sidebarwidth', iWidth);
    },

    populateRoleButtons : function() {
        if (!this.oSitemap) return;
        var oButton;
        var sTooltip;
        oButton = document.getElementById('snhome-button');
        if (this.oSitemap.oHome &&
            this.oSitemap.oHome.getAddress(this.preferedLanguages))
        {
            // TODO: Check for null 'document'.
            sTooltip = this.oSitemap.oHome.getName(this.preferedLanguages);
            if (this.oSitemap.oHome.getDescription(this.preferedLanguages) && this.oSitemap.oHome.getDescription(this.preferedLanguages) != "")
            {
                sTooltip += '\n' + this.oSitemap.oHome.getDescription(this.preferedLanguages);
            }             
            oButton.firstChild.setAttribute("label", sTooltip);
            this.createLink(oButton,
                            this.oSitemap.oHome
                            .getAddress(this.preferedLanguages).spec,
                            false);
        } else {
            this.removeLink(oButton);
        }

        oButton = document.getElementById('contact-button');
        if (this.oSitemap.oContact &&
            this.oSitemap.oContact.getAddress(this.preferedLanguages))
        {
            sTooltip = this.oSitemap.oContact.getName(this.preferedLanguages);
            if (this.oSitemap.oContact.getDescription(this.preferedLanguages) && this.oSitemap.oContact.getDescription(this.preferedLanguages) != "")
            {
                sTooltip += '\n' + this.oSitemap.oContact.getDescription(this.preferedLanguages);
            }             
            oButton.firstChild.setAttribute("label", sTooltip);
            this.createLink(oButton,
                            this.oSitemap.oContact
                            .getAddress(this.preferedLanguages).spec,
                            false);
        } else {
            this.removeLink(oButton);
        }

        oButton = document.getElementById('contentinfo-button');
        if (this.oSitemap.oContentInfo &&
            this.oSitemap.oContentInfo.getAddress(this.preferedLanguages))
        {
            sTooltip = this.oSitemap.oContentInfo.getName(this.preferedLanguages);
            if (this.oSitemap.oContentInfo.getDescription(this.preferedLanguages) && this.oSitemap.oContentInfo.getDescription(this.preferedLanguages) != "")
            {
                sTooltip += '\n' + this.oSitemap.oContentInfo.getDescription(this.preferedLanguages);
            }             
            oButton.firstChild.setAttribute("label", sTooltip);
            this.createLink(oButton,
                            this.oSitemap.oContentInfo
                            .getAddress(this.preferedLanguages).spec,
                            false);
        } else {
            this.removeLink(oButton);
        }
    },

    updateSearchBox : function() {
        if (!this.oSitemap) return;
        this.searchBox.childNodes[0].setAttribute("hasfocus", false);
        this.searchBox.childNodes[0].value =
            this.oSitemap.oSearch.getName(this.preferedLanguages);
        this.searchBox.setAttribute("tooltiptext",
                                    this.oSitemap.oSearch
                                    .getDescription(this.preferedLanguages));
    },

    getHistoryEntry : function() {
        var history = this.browser.sessionHistory;
        return history.getEntryAtIndex(history.index, false);
    },

    recoverTreeFromHistory : function(expectedSitemapURI) {
        // Recover sitemap structure.
        var history = this.browser.sessionHistory;
        this.lib.debug('Recovering [' + history.index + ']...?');
        data = this.historyItems[history.index];
        if (!data) {
            this.lib.debug('Recovering [' + history.index + ']: missing');
            return false;
        }
        if (false) {
            if (!expectedSitemapURI.equals(data.oSitemap.oSitemaURI)) {
                this.lib.debug('Recovering [' + history.index +
                               ']: found wrong URI (expected: ' +
                               expectedSitemapURI.spec + ' ; got: ' +
                               data.oSitemapURI.spec + ')');
                return false;
            }
        }
        this.lib.debug('Recovering [' + history.index + ']: found ' +
                       data.treeChildren.length + ' items');
        this.oSitemap = data.oSitemap;

        // Load tree items.
        var parent = this.tree.firstChild.nextSibling;
        this.lib.xulRemoveAllChildren(parent);
        for each (var ch in data.treeChildren) {
            parent.appendChild(ch);
        }
        this.treeItemList = data.treeItemList;

        // Make sure other aspects of the display are correct.
        this.updateSearchBox();
        this.populateRoleButtons();

        return true;
    },

    saveTreeInHistory : function() {
        var history = this.browser.sessionHistory;

        // Inject our own data into the history entry.
        var data = { };
        this.historyItems[history.index] = data;
        this.lib.debug('Saving [' + history.index + ']');

        data.oSitemap = this.oSitemap;
        data.treeChildren = [];
        for (var ch = this.tree.firstChild.nextSibling.firstChild;
             ch; ch = ch.nextSibling)
            data.treeChildren.push(ch);
        this.lib.debug('Saved ' + data.treeChildren.length + ' items')
        data.treeItemList = this.treeItemList;
    },

    newHistoryEntry : function() {
        var history = this.browser.sessionHistory;
        this.lib.debug('Purging [' + (history.index + 1) + '...]');
        this.historyItems.splice(history.index + 1);
    },

    historyPurge : function(iNumEntries) {
        this.lib.debug('Purging [0..' + iNumEntries + ']');
        this.historyItems.splice(0, iNumEntries);
    },

    historyItems : [],
}


//Initialization and destruction
window.addEventListener('load', function(event) {SitemapSidebar.onLoad(event);}, false);
window.addEventListener('unload', function(event) {SitemapSidebar.onUnload(event);}, false);


